> ## Documentation Index
> Fetch the complete documentation index at: https://docs.immutable.com/llms.txt
> Use this file to discover all available pages before exploring further.

# Refresh stacked metadata

> Refresh stacked metadata



## OpenAPI

````yaml https://imx-openapiv3-mr-sandbox.s3.us-east-2.amazonaws.com/openapi.json post /v1/chains/{chain_name}/collections/{contract_address}/metadata/refresh-metadata
openapi: 3.0.3
info:
  title: Immutable zkEVM API
  version: 1.0.0
  description: Immutable Multi Rollup API
  contact:
    name: Immutable API Support
    email: support@immutable.com
    url: https://support.immutable.com
servers:
  - url: https://api.sandbox.immutable.com
security: []
tags:
  - name: activities
    description: Activities Endpoints
    x-displayName: activities
  - name: chains
    description: Chains Endpoints
    x-displayName: chains
  - name: collections
    description: Collections Endpoints
    x-displayName: collections
  - name: nfts
    description: NFTs Endpoints
    x-displayName: nfts
  - name: nft owners
    description: NFT Owner Endpoints
    x-displayName: nft owners
  - name: metadata
    description: NFT Metadata Endpoints
    x-displayName: metadata
  - name: tokens
    description: ERC20 Token Endpoints
    x-displayName: tokens
  - name: demopage
    description: Temporary HTML endpoint for demo purposes
    x-displayName: demopage
  - name: verification
    x-displayName: verification
  - name: operatorallowlist
    x-displayName: operatorallowlist
  - name: crafting
    x-displayName: crafting
  - name: listings
    description: Listings Endpoints
    x-displayName: listings
  - name: orders
    x-displayName: orders
  - name: passport
    description: Passport operations
    x-displayName: passport
  - name: gamefi
    description: team gamefi
    x-displayName: gamefi
  - name: health
    x-displayName: health
  - name: passport profile
    description: Passport Profile endpoints
    x-displayName: passport profile
  - name: feed-items
    x-displayName: feed-items
  - name: assets
    x-displayName: assets
  - name: guardian
    description: Guardian endpoints
    x-displayName: guardian
  - name: pricing
    description: Pricing Endpoints
    x-displayName: pricing
  - name: metadata-search
    x-displayName: metadata-search
paths:
  /v1/chains/{chain_name}/collections/{contract_address}/metadata/refresh-metadata:
    post:
      tags:
        - metadata
      summary: Refresh stacked metadata
      description: Refresh stacked metadata
      operationId: RefreshMetadataByID
      parameters:
        - $ref: '#/components/parameters/ChainName'
        - $ref: '#/components/parameters/ContractAddress'
      requestBody:
        description: NFT Metadata Refresh Request
        required: true
        content:
          application/json:
            schema:
              $ref: '#/components/schemas/RefreshMetadataByIDRequest'
      responses:
        '202':
          description: Accepted
          headers:
            imx-refreshes-limit:
              $ref: '#/components/headers/MetadataRefreshLimit'
            imx-refresh-limit-reset:
              $ref: '#/components/headers/MetadataRefreshLimitReset'
            imx-remaining-refreshes:
              $ref: '#/components/headers/MetadataRefreshLimitRemaining'
            retry-after:
              $ref: '#/components/headers/MetadataRefreshRetryAfter'
          content:
            application/json:
              schema:
                $ref: '#/components/schemas/MetadataRefreshRateLimitResult'
        '400':
          $ref: '#/components/responses/BadRequest'
        '401':
          $ref: '#/components/responses/UnauthorisedRequest'
        '403':
          $ref: '#/components/responses/ForbiddenRequest'
        '404':
          $ref: '#/components/responses/NotFound'
        '429':
          $ref: '#/components/responses/TooManyMetadataRefreshes'
        '500':
          $ref: '#/components/responses/InternalServerError'
      security:
        - ImmutableApiKey:
            - refresh:metadata
components:
  parameters:
    ChainName:
      name: chain_name
      description: The name of chain
      in: path
      required: true
      schema:
        $ref: '#/components/schemas/ChainName'
      examples:
        testnet:
          value: imtbl-zkevm-testnet
          summary: Immutable zkEVM Public Testnet
    ContractAddress:
      name: contract_address
      in: path
      required: true
      description: Contract address
      schema:
        $ref: '#/components/schemas/Address'
  schemas:
    RefreshMetadataByIDRequest:
      type: object
      description: >-
        Request body for refreshing metadata by id. Total size of this list
        should not exceed 228 KiB
      properties:
        metadata:
          type: array
          maxItems: 10
          minItems: 1
          items:
            $ref: '#/components/schemas/RefreshMetadataByID'
      required:
        - metadata
    MetadataRefreshRateLimitResult:
      type: object
      properties:
        imx_refreshes_limit:
          type: string
        imx_refresh_limit_reset:
          type: string
        imx_remaining_refreshes:
          type: string
        retry_after:
          type: string
      required:
        - imx_refreshes_limit
        - imx_refresh_limit_reset
        - imx_remaining_refreshes
        - retry_after
    ChainName:
      type: string
      description: The name of chain
      example: imtbl-zkevm-testnet
    Address:
      x-go-type: common.Address
      x-go-type-import:
        path: github.com/ethereum/go-ethereum/common
        name: common
      description: An Ethereum address
      type: string
      example: '0xe9b00a87700f660e46b6f5deaa1232836bcc07d3'
      pattern: ^0x[a-fA-F0-9]{40}$
    RefreshMetadataByID:
      allOf:
        - $ref: '#/components/schemas/RefreshableNFTAttributes'
        - type: object
          properties:
            metadata_id:
              $ref: '#/components/schemas/MetadataID'
          required:
            - metadata_id
    APIError400:
      allOf:
        - $ref: '#/components/schemas/BasicAPIError'
        - type: object
          properties:
            code:
              type: string
              description: Error Code
              enum:
                - VALIDATION_ERROR
              example: VALIDATION_ERROR
            details:
              type: object
              nullable: true
              description: Additional details to help resolve the error
          required:
            - code
            - details
    APIError401:
      allOf:
        - $ref: '#/components/schemas/BasicAPIError'
        - type: object
          properties:
            code:
              type: string
              description: Error Code
              enum:
                - UNAUTHORISED_REQUEST
              example: UNAUTHORISED_REQUEST
            details:
              type: object
              nullable: true
              description: Additional details to help resolve the error
          required:
            - code
            - details
    APIError403:
      allOf:
        - $ref: '#/components/schemas/BasicAPIError'
        - type: object
          properties:
            code:
              type: string
              description: Error Code
              enum:
                - AUTHENTICATION_ERROR
              example: AUTHENTICATION_ERROR
            details:
              type: object
              nullable: true
              description: Additional details to help resolve the error
          required:
            - code
            - details
    APIError404:
      allOf:
        - $ref: '#/components/schemas/BasicAPIError'
        - type: object
          properties:
            code:
              type: string
              description: Error Code
              enum:
                - RESOURCE_NOT_FOUND
              example: RESOURCE_NOT_FOUND
            details:
              type: object
              nullable: true
              description: Additional details to help resolve the error
          required:
            - code
            - details
    APIError429:
      allOf:
        - $ref: '#/components/schemas/BasicAPIError'
        - type: object
          properties:
            code:
              type: string
              description: Error Code
              enum:
                - TOO_MANY_REQUESTS_ERROR
              example: TOO_MANY_REQUESTS_ERROR
            details:
              type: object
              nullable: true
              description: Additional details to help resolve the error
          required:
            - code
            - details
    APIError500:
      allOf:
        - $ref: '#/components/schemas/BasicAPIError'
        - type: object
          properties:
            code:
              type: string
              description: Error Code
              enum:
                - INTERNAL_SERVER_ERROR
              example: INTERNAL_SERVER_ERROR
            details:
              type: object
              nullable: true
              description: Additional details to help resolve the error
          required:
            - code
            - details
    RefreshableNFTAttributes:
      allOf:
        - $ref: '#/components/schemas/NFTMetadataRequest'
      required:
        - name
        - description
        - image
        - external_url
        - animation_url
        - youtube_url
        - attributes
    MetadataID:
      description: Metadata id in UUIDv4 format
      type: string
      format: uuid
      example: 4e28df8d-f65c-4c11-ba04-6a9dd47b179b
    BasicAPIError:
      type: object
      properties:
        message:
          type: string
          description: Error Message
          example: all fields must be provided
        link:
          type: string
          description: Link to IMX documentation that can help resolve this error
          example: https://docs.x.immutable.com/reference/#/
        trace_id:
          type: string
          description: Trace ID of the initial request
          example: e47634b79a5cd6894ddc9639ec4aad26
      required:
        - message
        - link
        - trace_id
    NFTMetadataRequest:
      type: object
      description: The NFT metadata. Total size of this object should not exceed 16 KiB
      properties:
        name:
          type: string
          nullable: true
          example: Sword
          description: The name of the NFT
        description:
          type: string
          nullable: true
          example: '2022-08-16T17:43:26.991388Z'
          description: The description of the NFT
        image:
          type: string
          nullable: true
          description: The image url of the NFT
          example: https://some-url
        external_url:
          type: string
          nullable: true
          description: The external link of the NFT
          example: https://some-url
        animation_url:
          type: string
          nullable: true
          description: The animation url of the NFT
          example: https://some-url
        youtube_url:
          type: string
          nullable: true
          description: The youtube link of the NFT
          example: https://some-url
        attributes:
          type: array
          description: List of Metadata attributes
          nullable: true
          items:
            $ref: '#/components/schemas/NFTMetadataAttribute'
    NFTMetadataAttribute:
      type: object
      properties:
        display_type:
          description: Display type for this attribute
          type: string
          nullable: true
          enum:
            - number
            - boost_percentage
            - boost_number
            - date
          example: number
        trait_type:
          description: The metadata trait type
          type: string
          example: Aqua Power
        value:
          oneOf:
            - type: string
            - type: number
            - type: boolean
          description: The metadata trait value
          example: Happy
      required:
        - trait_type
        - value
  headers:
    MetadataRefreshLimit:
      description: >-
        The refresh request limit available to the project for each one-hour
        window.
      schema:
        type: string
    MetadataRefreshLimitReset:
      description: The expiry date of the current one-hour window.
      schema:
        type: string
    MetadataRefreshLimitRemaining:
      description: The number of refresh requests remaining in the current window.
      schema:
        type: string
    MetadataRefreshRetryAfter:
      description: The number of seconds until the next refresh request can be made.
      schema:
        type: string
  responses:
    BadRequest:
      description: Bad Request (400)
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/APIError400'
    UnauthorisedRequest:
      description: Unauthorised Request (401)
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/APIError401'
    ForbiddenRequest:
      description: Forbidden Request (403)
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/APIError403'
    NotFound:
      description: The specified resource was not found (404)
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/APIError404'
    TooManyMetadataRefreshes:
      description: Too Many Metadata refreshes (429)
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/APIError429'
      headers:
        imx-refreshes-limit:
          $ref: '#/components/headers/MetadataRefreshLimit'
        imx-refresh-limit-reset:
          $ref: '#/components/headers/MetadataRefreshLimitReset'
        imx-remaining-refreshes:
          $ref: '#/components/headers/MetadataRefreshLimitRemaining'
        Retry-After:
          $ref: '#/components/headers/MetadataRefreshRetryAfter'
    InternalServerError:
      description: Internal Server Error (500)
      content:
        application/json:
          schema:
            $ref: '#/components/schemas/APIError500'
  securitySchemes:
    ImmutableApiKey:
      x-go-name: ImmutableApiKey
      type: apiKey
      in: header
      name: x-immutable-api-key

````